#ifndef __STDDIN_H
#define __STDDIN_H
//
//  (C) Copyright 1993-2008 by Autodesk, Inc.  All rights reserved.
//
// Permission to use, copy, modify, and distribute this software in
// object code form for any purpose and without fee is hereby granted, 
// provided that the above copyright notice appears in all copies and 
// that both that copyright notice and the limited warranty and
// restricted rights notice below appear in all supporting 
// documentation.
//
// AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS. 
// AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
// MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC. 
// DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
// UNINTERRUPTED OR ERROR FREE.
//
// Use, duplication, or disclosure by the U.S. Government is subject to 
// restrictions set forth in FAR 52.227-19 (Commercial Computer
// Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
// (Rights in Technical Data and Computer Software), as applicable.
//

#ifndef __STDISO_H
	#error include 'stdISO.h' before including this file
#endif

class STDIMP_DLLSHARE AcmStandardDIN : public AcmStandard
{
public:
  ACRX_DECLARE_MEMBERS(AcmStandardDIN);

  AcmStandardDIN();
  virtual ~AcmStandardDIN();

  virtual LPCTSTR originalName() const;             

  virtual Adesk::Boolean acmInit();             

  virtual void getTextHeightList(AcGeDoubleArray& txtArr) const;

  virtual Adesk::Boolean setFactoryDefaults();
  virtual Adesk::Boolean setDimDefaults();

protected:
  virtual void initArrowServices();
  virtual Adesk::Boolean createDefaultStyle();
};                      

MAKE_ACDBOPENOBJECT_FUNCTION(AcmStandardDIN);


class STDIMP_DLLSHARE AcmSurfTextStdDIN : public AcmSurfTextStdISO
{
public:
  ACRX_DECLARE_MEMBERS(AcmSurfTextStdDIN);
    
  AcmSurfTextStdDIN();             
  virtual ~AcmSurfTextStdDIN();             

  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Adesk::Boolean   isCompatibleTo(const AcmStandard* pStd) const;

  virtual Adesk::Boolean setFactoryDefaults();

  virtual Adesk::Boolean getLaySymbolList(AcmCObjArray<AcmCSymbolDesc>& list,
                                          const AcmCSurfText* pSubSym =NULL) const;

  // Function is added to allow DIN standard to show comma as
  // the decimal separator.
  virtual void getDefaultVarSuggestList(Acm::Variable var, CStringList& list) const;
  virtual void getDefaultCutOffList(CStringList& list) const;
  virtual void getDefaultWavinessList(CStringList& list) const;
  virtual void getDefaultRoughnessList(CStringList& list) const;
};                      

MAKE_ACDBOPENOBJECT_FUNCTION(AcmSurfTextStdDIN);

class STDIMP_DLLSHARE AcmSurfTextStdDIN2002 : public AcmSurfTextStdDIN
{
public:
  ACRX_DECLARE_MEMBERS(AcmSurfTextStdDIN2002);

  AcmSurfTextStdDIN2002();
  virtual ~AcmSurfTextStdDIN2002();

  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Acad::ErrorStatus getVarFromDlgIndex(Adesk::UInt8 dlgIndex, Acm::Variable& var) const;
  virtual AcmSurfTextStd::ConfigListState checkConfigListState(Acm::Variable var, CVarDlgInfo& varDlgInfo) const;
  virtual Acm::ErrorStatus checkVisibility(AcmCSurfText* pData) const;
  virtual Acm::ErrorStatus initFields(AcmCSurfText* pData) const ;
  virtual Acm::ErrorStatus setSuggested(AcmCSurfText* pData) const;
  virtual void restoreAllSuggestedList();
  virtual void getDefaultVarSuggestList(Acm::Variable var, CStringList& list) const;

protected:
  virtual void getHeights(const AcmCSurfText* pSymb,
                          double& H1,
                          double& H2) const;
};                      

MAKE_ACDBOPENOBJECT_FUNCTION(AcmSurfTextStdDIN2002);

class STDIMP_DLLSHARE AcmFCFStdDIN : public AcmFCFStd
{
public:
  ACRX_DECLARE_MEMBERS(AcmFCFStdDIN);

  AcmFCFStdDIN();
  virtual ~AcmFCFStdDIN();

  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Adesk::Boolean   isCompatibleTo(const AcmStandard* pStd) const;
  
  virtual Adesk::Boolean setFactoryDefaults();
  virtual void initToEditOriginal();
  virtual void initToEdit();

  virtual Adesk::Boolean getArrowDesc(AcmCObjArray<AcmCArrowDesc>& list,Adesk::Boolean allSrv = Adesk::kTrue) const;

  virtual Adesk::Boolean getMat(AcmCObjArray<AcmCGDTSymbolDesc>& list) const;

  virtual Acm::ErrorStatus checkVisibility(AcmCFCF* pData) const;
  virtual Acm::ArrowType defaultSecondaryArrowType() const;
};                      

MAKE_ACDBOPENOBJECT_FUNCTION(AcmFCFStdDIN);


class STDIMP_DLLSHARE AcmWeldingStdDIN : public AcmWeldingStdISO
{
public:
  ACRX_DECLARE_MEMBERS(AcmWeldingStdDIN);

  AcmWeldingStdDIN();             
  virtual ~AcmWeldingStdDIN();             

  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Adesk::Boolean   isCompatibleTo(const AcmStandard* pStd) const;

  virtual Acm::ErrorStatus cInit();             
  virtual Adesk::Boolean setFactoryDefaults();
};                      

MAKE_ACDBOPENOBJECT_FUNCTION(AcmWeldingStdDIN);


class STDIMP_DLLSHARE AcmDatumStdDIN : public AcmDatumStdISO
{
public:
  ACRX_DECLARE_MEMBERS(AcmDatumStdDIN);

  AcmDatumStdDIN();
  virtual ~AcmDatumStdDIN();

  virtual Adesk::Boolean   isCompatibleTo(const AcmStandard* pStd) const;

  virtual Adesk::Boolean setFactoryDefaults();
  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
};                      

MAKE_ACDBOPENOBJECT_FUNCTION(AcmDatumStdDIN);

class STDIMP_DLLSHARE AcmCPartListStdDIN : public AcmCPartListStd
{
public:
  AcmCPartListStdDIN(AcmBOMStd *std);
  virtual ~AcmCPartListStdDIN();

  virtual Adesk::Boolean setFactoryDefaults();
  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;

};

class STDIMP_DLLSHARE AcmCBalloonStdDIN : public AcmCBalloonStd
{
public:
  AcmCBalloonStdDIN(AcmBOMStd *std);
  virtual ~AcmCBalloonStdDIN();

  virtual Adesk::Boolean setFactoryDefaults();
  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;

};

class STDIMP_DLLSHARE AcmBOMStdDIN : public AcmBOMStd
{
public:
  ACRX_DECLARE_MEMBERS(AcmBOMStdDIN);

  AcmBOMStdDIN();
  virtual ~AcmBOMStdDIN();

  virtual Acm::ErrorStatus cInit();
  virtual Adesk::Boolean setFactoryDefaults();

  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Adesk::Boolean   isCompatibleTo(const AcmStandard* pStd) const;
};

MAKE_ACDBOPENOBJECT_FUNCTION(AcmBOMStdDIN);

class STDIMP_DLLSHARE AcmIdStdDIN : public AcmIdStdISO
{
public:
  ACRX_DECLARE_MEMBERS(AcmIdStdDIN);
  
  AcmIdStdDIN();
  virtual ~AcmIdStdDIN();

  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Adesk::Boolean   isCompatibleTo(const AcmStandard* pStd) const;

  virtual Adesk::Boolean getDatumArrowDesc(AcmCObjArray<AcmCArrowDesc>& list) const;
};
MAKE_ACDBOPENOBJECT_FUNCTION(AcmIdStdDIN);

#endif // STDDIN
